/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

int se_in_ForallStmt = 0;
/*** BOZKUs **/
/*
Node *transfer_to_forall(root)
Node *root;
{
 new = make (FORALL_STMT);
 new->ForallStmt.Forall = &Forall;
 new->ForallStmt.Lp = &Lp;
 new->ForallStmt.ForallTripletSpecList = make_triplet(root);
 new->ForallStmt.OptScalarMaskExpr = NN;
 new->ForallStmt.Rp = &Rp;
 new->ForallStmt.Stmt = root;
 return new;
}

Node *make_triplet(root)
Node *root;
{
 new = make (FORALL_TRIPLET_SPEC_LIST);

 new->ForallTripletSpecList.ForallTripletSpecList =
 new->ForallTripletSpecList.Comma = &Comma;
 new->ForallTripletSpecList.ForallTripletSpec = 

 spec = make (FORALL_TRIPLET_SPEC);
                yyval.node->ForallTripletSpec.Name = yypvt[-6].node;
                yyval.node->ForallTripletSpec.Eq = &Eq;
                yyval.node->ForallTripletSpec.Expr = yypvt[-4].node;
                yyval.node->ForallTripletSpec.Colon = &Colon;
                yyval.node->ForallTripletSpec.Expr1 = yypvt[-2].node;
                yyval.node->ForallTripletSpec.Colon1 = &Colon;
                yyval.node->ForallTripletSpec.Expr2 = yypvt[-0].node;


*/



Node *check_ForallStmt_down (node)
Node *node;
{
	se_in_ForallStmt = 1;
	return node;
}

Node *check_ForallStmt (node)
Node *node;
{
	Node *astmt = node->ForallStmt.Stmt;
	Node *var, *expr;
	T_Entry *entry;
	struct S_OptScalarMaskExpr *osme;
	Node *triplet, *temp;
	int rank;

	for (LIST_LOOP (triplet, node->ForallStmt.ForallTripletSpecList, temp))
		check_ForallTripletSpec (triplet);

	if (astmt->com.type != ASSIGNEMENT_STMT) {
		fatal ("statement in FORALL is not an assignement");
		return node;
	}

        /* BOZKUS */
/*        distribute_loop_forall(node);*/
       /* END */


	var  = astmt->AssignementStmt.Variable;
        find_parti_size(var);
	expr = astmt->AssignementStmt.Expr;

	if (node->ForallStmt.OptScalarMaskExpr != NN) {
		osme = &node->ForallStmt.OptScalarMaskExpr->OptScalarMaskExpr;

		if (osme->Expr->com.typ->etype->type != TYP_LOGICAL) {
			sprintf (serr, "mask expression in FORALL must be LOGICAL, is %s"
			, etype_name (osme->Expr->com.typ->etype));
			fatal (serr);
		}

		if (rank = RANK_FROM_SHAPE (osme->Expr->com.typ->shape)) {
			sprintf (serr, "mask expression in FORALL must be scalar, is of rank %d"
			, rank);
			fatal (serr);
			return node;
		}
	}


	if (!misc_var_is_in_both (var, expr)
	&& (
	    node->ForallStmt.OptScalarMaskExpr == NN
	 || !misc_var_is_in_both (var, osme->Expr)))
		return node;

	if ((entry = lookup_loc (var->com.str)) == TN)
		return node;
/** BOZKUS **/
/* This part will be changet when thre is A = A kind of forall */

/* node->ForallStmt.var = temp_make (entry->typ, 1, &node->ForallStmt.upd); */
	
	se_in_ForallStmt = 0;
	return node;
}

Node *check_ForallTripletSpec (node)
Node *node;
{
	struct S_ForallTripletSpec *triplet = &node->ForallTripletSpec;
	int rank;
	double value;

	parse_name (triplet->Name);

	if (triplet->Name->com.typ->etype->type != TYP_INTEGER) {
		sprintf (serr, "index '%s' in FORALL must be INTEGER, is %s"
		, triplet->Name->com.str, etype_name (triplet->Name->com.typ->etype));	
		fatal (serr);
	}

	if (rank = RANK_FROM_SHAPE (triplet->Name->com.typ->shape)) {
		sprintf (serr, "index '%s' in FORALL must be scalar, is of rank %d"
		, triplet->Name->com.str, rank);
		fatal (serr);
	}

	if (triplet->Expr2 != NN
	&& expr_is_constant (triplet->Expr2, &value)
	&& value == 0)
		fatal ("stride in FORALL statement has the value 0");

	return node;
}

static int num_triplet = 0;

static write_forall_triplet (tripletlist)
Node *tripletlist;
{
	Node *triplet, *temp;
	struct S_ForallTripletSpec *trip;
	int num;

	num = 0;
	for (LIST_LOOP (triplet, tripletlist, temp)) {
                if(triplet==NN) {num=0;break;} /* BOZKUS */
		if (num) {
			otab ();
			oDO ();
		}
		else
			oDO ();	

		trip = &triplet->ForallTripletSpec;

		onam (trip->Name->com.str);
		ochb ('=');
		onod (trip->Expr);
		ochb (',');
		onod (trip->Expr1);

		if (trip->Expr2 != NN) {
			ochb (',');
			onod (trip->Expr2);
		}

		odon ();

		num++;
	}

	num_triplet = num;
}

static write_forall_enddos ()
{
	int i;

	for (i = 0; i < num_triplet; i++) {
		otab ();
		oEND_DO ();

		if (i != num_triplet - 1)
			odon ();
	}
}

write_ForallStmt (stmt)
Node *stmt;
{
	struct S_ForallStmt *forall = &stmt->ForallStmt;
	Node *tripletlist = forall->ForallTripletSpecList;
	int i, replace = forall->var != NN;
	Node *maskexpr;
	struct S_AssignementStmt *astmt = &forall->Stmt->AssignementStmt;
	Node *var, *var1, *rvar, *rvar1, *uvar, *expr;
	char *old_name, *rep_name;
	Trans *trans_ref, *trans_upd;

	if ((maskexpr = stmt->ForallStmt.OptScalarMaskExpr) != NN)
		maskexpr = maskexpr->OptScalarMaskExpr.Expr;
	
	if (replace) {
		var = astmt->Variable;
		expr = astmt->Expr;
		rvar = forall->var;
		uvar = forall->upd;
		rvar1 = tree_dup (forall->var);
		var1 = tree_dup (var);

		trans_ref = forall->var->com.trans;
		trans_upd = forall->upd->com.trans;
		forall->var->com.trans = (Trans*) 0;
		forall->upd->com.trans = (Trans*) 0;

		rvar->ArraySection.SubscriptList  = tree_dup (var->ArraySection.SubscriptList);	
		rvar1->ArraySection.SubscriptList = tree_dup (var->ArraySection.SubscriptList);	
		uvar->ArraySection.SubscriptList  = tree_dup (var->ArraySection.SubscriptList);	
		var1->ArraySection.SubscriptList  = tree_dup (var->ArraySection.SubscriptList);	
		rvar->com.typ = var->com.typ;
		rvar1->com.typ = var->com.typ;
		uvar->com.typ = var->com.typ;
		var1->com.typ = var->com.typ;

		if ((trans_ref != TRN && trans_ref->nbef)
		||  (trans_upd != TRN && trans_upd->nbef)) {
			odon ();
			oend ();
			sta_write_trans_bef (trans_ref);
			sta_write_trans_bef (trans_upd);
			ostart ();
			otab ();
		}

/* TEMP = VAR */

		if (maskexpr != NN) {
			astmt->Variable = rvar1;
			astmt->Expr = var1;

			write_forall_triplet (tripletlist);
			otab ();
			onod (stmt->ForallStmt.Stmt);
			odon ();
			write_forall_enddos ();
			odon ();
			otab ();
		}

/* TEMP = EXPR (with MASK)*/

		astmt->Variable = rvar;
		astmt->Expr = expr;
	}

/* BOZKUS */
/* I make it sta will be writed before tiplet and also for aft after end dos */
	sta_write_sta_bef (forall->statement);
/* END */

	write_forall_triplet (tripletlist);

	oend ();
/*	sta_write_sta_bef (forall->statement);*/
	ostart ();

	if (maskexpr != NN) {
		otab ();
		oIF ();
		oLP ();
		onod (maskexpr);
		oRP ();
		oTHEN ();
		odon ();
	}

	otab ();
	onod (stmt->ForallStmt.Stmt);
	odon ();

	if (maskexpr != NN) {
		otab ();
		oEND_IF ();
		odon ();
	}

	oend ();
	sta_write_sta_aft (stmt->ForallStmt.statement); 
	ostart ();

	write_forall_enddos ();
	if (replace) {
		odon ();
		otab ();
		write_forall_triplet (tripletlist);

		astmt->Variable = var;
		astmt->Expr     = uvar;

		otab ();
		onod (stmt->ForallStmt.Stmt);
		odon ();

		write_forall_enddos ();

		odon ();
		oend ();
		sta_write_trans_aft (trans_ref);
		sta_write_trans_aft (trans_upd);
		ostart ();
	}
}
